题目描述
给定整数 p
和 m
,一个长度为 k
且下标从 0 开始的字符串 s
的哈希值按照如下函数计算:
hash(s, p, m) = (val(s[0]) * p0 + val(s[1]) * p1 + ... + val(s[k-1]) * pk-1) mod m
.
其中 val(s[i])
表示 s[i]
在字母表中的下标,从 val('a') = 1
到 val('z') = 26
。
给你一个字符串 s
和整数 power
,modulo
,k
和 hashValue
。请你返回 s
中 第一个 长度为 k
的 子串 sub
,满足 hash(sub, power, modulo) == hashValue
。
测试数据保证一定 存在 至少一个这样的子串。
子串 定义为一个字符串中连续非空字符组成的序列。
示例 1:
输入:s = "leetcode", power = 7, modulo = 20, k = 2, hashValue = 0
输出:"ee"
解释:"ee" 的哈希值为 hash("ee", 7, 20) = (5 * 1 + 5 * 7) mod 20 = 40 mod 20 = 0 。
"ee" 是长度为 2 的第一个哈希值为 0 的子串,所以我们返回 "ee" 。
示例 2:
输入:s = "fbxzaad", power = 31, modulo = 100, k = 3, hashValue = 32
输出:"fbx"
解释:"fbx" 的哈希值为 hash("fbx", 31, 100) = (6 * 1 + 2 * 31 + 24 * 312) mod 100 = 23132 mod 100 = 32 。
"bxz" 的哈希值为 hash("bxz", 31, 100) = (2 * 1 + 24 * 31 + 26 * 312) mod 100 = 25732 mod 100 = 32 。
"fbx" 是长度为 3 的第一个哈希值为 32 的子串,所以我们返回 "fbx" 。
注意,"bxz" 的哈希值也为 32 ,但是它在字符串中比 "fbx" 更晚出现。
提示:
1 <= k <= s.length <= 2 * 104
1 <= power, modulo <= 109
0 <= hashValue < modulo
s
只包含小写英文字母。
- 测试数据保证一定 存在 满足条件的子串。
解法
方法一:滑动窗口 + 倒序遍历
我们可以维护一个长度为 $k$ 的滑动窗口,用来计算子串的哈希值。考虑到如果正序遍历字符串,在哈希值的计算中,涉及到除法取模的操作,处理起来比较麻烦。因此我们可以倒序遍历字符串,这样在计算哈希值的时候,只需要乘法和取模操作。
我们首先计算字符串末尾的 $k$ 个字符的哈希值,然后从字符串末尾开始倒序遍历,每次计算当前窗口的哈希值,如果等于给定的哈希值,我们就找到了一个满足条件的子串,更新答案字符串的起始位置。
最后返回答案字符串即可。
时间复杂度 $O(n)$,其中 $n$ 是字符串的长度。空间复杂度 $O(1)$。
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19 | class Solution:
def subStrHash(
self, s: str, power: int, modulo: int, k: int, hashValue: int
) -> str:
h, n = 0, len(s)
p = 1
for i in range(n - 1, n - 1 - k, -1):
val = ord(s[i]) - ord("a") + 1
h = ((h * power) + val) % modulo
if i != n - k:
p = p * power % modulo
j = n - k
for i in range(n - 1 - k, -1, -1):
pre = ord(s[i + k]) - ord("a") + 1
cur = ord(s[i]) - ord("a") + 1
h = ((h - pre * p) * power + cur) % modulo
if h == hashValue:
j = i
return s[j : j + k]
|
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23 | class Solution {
public String subStrHash(String s, int power, int modulo, int k, int hashValue) {
long h = 0, p = 1;
int n = s.length();
for (int i = n - 1; i >= n - k; --i) {
int val = s.charAt(i) - 'a' + 1;
h = ((h * power % modulo) + val) % modulo;
if (i != n - k) {
p = p * power % modulo;
}
}
int j = n - k;
for (int i = n - k - 1; i >= 0; --i) {
int pre = s.charAt(i + k) - 'a' + 1;
int cur = s.charAt(i) - 'a' + 1;
h = ((h - pre * p % modulo + modulo) * power % modulo + cur) % modulo;
if (h == hashValue) {
j = i;
}
}
return s.substring(j, j + k);
}
}
|
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24 | class Solution {
public:
string subStrHash(string s, int power, int modulo, int k, int hashValue) {
long long h = 0, p = 1;
int n = s.size();
for (int i = n - 1; i >= n - k; --i) {
int val = s[i] - 'a' + 1;
h = ((h * power % modulo) + val) % modulo;
if (i != n - k) {
p = p * power % modulo;
}
}
int j = n - k;
for (int i = n - k - 1; i >= 0; --i) {
int pre = s[i + k] - 'a' + 1;
int cur = s[i] - 'a' + 1;
h = ((h - pre * p % modulo + modulo) * power % modulo + cur) % modulo;
if (h == hashValue) {
j = i;
}
}
return s.substr(j, k);
}
};
|
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21 | func subStrHash(s string, power int, modulo int, k int, hashValue int) string {
h, p := 0, 1
n := len(s)
for i := n - 1; i >= n-k; i-- {
val := int(s[i] - 'a' + 1)
h = (h*power%modulo + val) % modulo
if i != n-k {
p = p * power % modulo
}
}
j := n - k
for i := n - k - 1; i >= 0; i-- {
pre := int(s[i+k] - 'a' + 1)
cur := int(s[i] - 'a' + 1)
h = ((h-pre*p%modulo+modulo)*power%modulo + cur) % modulo
if h == hashValue {
j = i
}
}
return s[j : j+k]
}
|
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29 | function subStrHash(
s: string,
power: number,
modulo: number,
k: number,
hashValue: number,
): string {
let h: bigint = BigInt(0),
p: bigint = BigInt(1);
const n: number = s.length;
const mod = BigInt(modulo);
for (let i: number = n - 1; i >= n - k; --i) {
const val: bigint = BigInt(s.charCodeAt(i) - 'a'.charCodeAt(0) + 1);
h = (((h * BigInt(power)) % mod) + val) % mod;
if (i !== n - k) {
p = (p * BigInt(power)) % mod;
}
}
let j: number = n - k;
for (let i: number = n - k - 1; i >= 0; --i) {
const pre: bigint = BigInt(s.charCodeAt(i + k) - 'a'.charCodeAt(0) + 1);
const cur: bigint = BigInt(s.charCodeAt(i) - 'a'.charCodeAt(0) + 1);
h = ((((h - ((pre * p) % mod) + mod) * BigInt(power)) % mod) + cur) % mod;
if (Number(h) === hashValue) {
j = i;
}
}
return s.substring(j, j + k);
}
|
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31 | /**
* @param {string} s
* @param {number} power
* @param {number} modulo
* @param {number} k
* @param {number} hashValue
* @return {string}
*/
var subStrHash = function (s, power, modulo, k, hashValue) {
let h = BigInt(0),
p = BigInt(1);
const n = s.length;
const mod = BigInt(modulo);
for (let i = n - 1; i >= n - k; --i) {
const val = BigInt(s.charCodeAt(i) - 'a'.charCodeAt(0) + 1);
h = (((h * BigInt(power)) % mod) + val) % mod;
if (i !== n - k) {
p = (p * BigInt(power)) % mod;
}
}
let j = n - k;
for (let i = n - k - 1; i >= 0; --i) {
const pre = BigInt(s.charCodeAt(i + k) - 'a'.charCodeAt(0) + 1);
const cur = BigInt(s.charCodeAt(i) - 'a'.charCodeAt(0) + 1);
h = ((((h - ((pre * p) % mod) + mod) * BigInt(power)) % mod) + cur) % mod;
if (Number(h) === hashValue) {
j = i;
}
}
return s.substring(j, j + k);
};
|